$!   VUE$POPMESSAGE.com
$!
$!   David Mathog, 2-DEC-1994, Biology Division, Caltech
$!
$!   This can be used by other DECwindows "VERBs" to place popup windows
$!   on the screen - without hanging if there is nobody there to service
$!   them.  Primarily for use with VUE$TIMEOUT.
$! 
$!   It maintains two files:
$!   VUE$POPUP.MESSAGE   the file it reads from and then deletes
$!   VUE$POPUP.PID       the PID of the current process
$!
$!*******************************************************************
$!
$    D_interval = "2:00" 
$    my_name       = "POP_" + f$getjpi("","USERNAME")
$    line_feed[0,8] = 10
$!
$!   try to change the name of this process to my_name
$!   if it fails, that means that one is already running. Don't want two!
$!   There could be two for two reasons:
$!     1.  Two rexec/rshells from the same remote terminal.
$!     2.  Two sessions running on different terminals.
$!   What we do here is try to set the name.  If it fails, we wait interval
$!   and try again.  Only if we succeed do we proceed to set up idle job
$!   monitoring.
$!             
$DUPLOOP:
$    set process/name='my_name'
$    if $STATUS then goto EXDUPLOOP
$    wait 'D_interval'
$    goto DUPLOOP
$EXDUPLOOP:
$!
$!   write the current PID into a file - makes life easier for other
$!   processes when they need to wake this one.
$!
$ open/write tfil: vue$popup.pid
$ my_PID        = f$getjpi("","PID")
$ write tfil: my_PID
$ close tfil:
$ purge vue$popup.pid
$ rename vue$popup.pid; ;1
$!
$!   Now suspend the process until somebody else wakes it up
$!
$ set process/suspend
$!
$!   If we got here, then somebody said to pop up a message
$!
$    string = line_feed
$    open/error=o_error/read tfil: sys$login:vue$popup.message
$!
$!   This loop reads in all the lines of the message.
$!   It puts line feeds between each line so that they will come out
$!   as separate lines on the screen.
$!
$STRLOOP:
$    read/end=done/error=oops tfil: chunk
$    string = string + line_feed + chunk
$    goto STRLOOP
$DONE:
$    close tfil:
$!
$!   Delete any and all message files.
$!
$    delete sys$login:vue$popup.message.*
$    vue$popup_confirm string
$    vue$read nonsense
$    goto EXDUPLOOP
$!
$OOPS:
$    close tfil:
$    vue$popup_confirm line_feed,-
     "Error reading SYS$LOGIN:VUE$POPUP.MESSAGE",line_feed,-
     "(Click either button to dismiss this window)",line_feed
$    vue$read nonsense
$    goto EXDUPLOOP
$    
$O_ERROR:
$    vue$popup_confirm line_feed,-
     "Error - could not open SYS$LOGIN:VUE$POPUP.MESSAGE",line_feed,-
     "(Click either button to dismiss this window)",line_feed
$    vue$read nonsense
$    goto EXDUPLOOP
